/* GCC */

#include <iostream>

#include <stdio.h>

#include <math.h>

using namespace std;

int GGT(int p, int q){

    while(p!=0 && q!=0){

        if(p>q) p=p%q;
        else q=q%p;

    }

    return p+q;

}

pair < int, int > sum(pair < int, int> x, pair < int, int > y){

    int p=x.first*y.second+x.second*y.first;

    int q=x.second*y.second;

    int z=GGT(p,q);

    p=p/z;

    q=q/z;

    return( make_pair(p,q));

}

pair < int, int > par(pair < int, int> x, pair < int, int > y){

    int r=x.second*y.first+x.first*y.second;

    int t=x.first*y.first;

    int z=GGT(r,t);

    r=r/z;

    t=t/z;

    return( make_pair(r,t));

}

int main(){

    freopen("resistor.in", "r", stdin);

    freopen("resistor.out", "w", stdout);

    int n, m;

    cin >> n >> m;

    pair < int, int > c[n][n];

    int a,b, mn, lcz;

    for(int i=0; i<n; i++){

        for(int j=0; j<n; j++){

            c[n][n].first=0;

            c[n][n].second=1;

        }

    }

    for(int i=0; i<m; i++){

        scanf("%d %d %d %d", &a, &b, &mn, &lcz);

        a--; b--; pair < int, int> k=make_pair(mn, lcz);

        if(c[a][b].first==0){

            c[a][b]=k;

            c[b][a]=k;

        }
        else{

            c[a][b]=par(c[a][b], k);

            c[b][a]=c[a][b];

        }

    }

    pair < int, int> res;

    res.first=0; res.second=1;

    for(int i=0; i<n; i++){

        for(int j=0; j<n; j++){

            res=sum(res, c[i][j]);

        }

    }

    res.second=res.second*2;

    res.second=res.second/GGT(res.first, res.second);

    res.first=res.first/GGT(res.first, res.second);

    if(res.second!=1) cout << res.first << "/" << res.second << endl;
    else cout << res.first << endl;

}
