/* GCC */

#include <fstream>
#include <iostream>
#include <cstdlib>
using namespace std;

#define NAME "profit"

#define SIZE 102

static int a[SIZE][SIZE];
static int b[SIZE][SIZE];
static int c[SIZE][SIZE];
static int q[SIZE];

int main()
{
    ifstream fin(NAME ".in");
    ofstream fout(NAME ".out");
    fin.sync_with_stdio(false);
    fout.sync_with_stdio(false);

    int n, m;
    fin >> m >> n;

    for (int i = 1; i <= m; ++i)
        for (int j = 1; j <= n; ++j)
            fin >> a[i][j];

    for (int i = 0; i <= m; ++i)
    {
         b[i][1] = a[i][1];
         c[i][1] = i;
    }


    for (int j = 1; j <= m; ++j)
    {
        for (int k = 2; k <= n; ++k)
        {
            int l = 0;
            int max = 0;
            for (int z = 0; z <= j; ++z)
            {
                if (b[j-z][k-1] + a[z][k] > max)
                {
                    max = b[j-z][k-1] + a[z][k];
                    l = z;
                }
            }
            b[j][k] = max;
            c[j][k] = l;
        }
    }

    fout << b[m][n] << endl;
    int j = m, k = n;
   do
    {
        while (k > 1 && b[j][k] == b[j][k-1])
            --k;
        q[k] = c[j][k];
        j -= c[j][k];
        --k;
    }
    while (j != 0 || k != 0);

    for (int i = 1; i <= n; ++i)
        fout << q[i] << ((i != n)?" ":"\n");

    fin.close();
    fout.close();
    return 0;
}


