/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#define N 101

using namespace std;

int m; // money
int n; // banks

struct deal {
    int bank;
    int profit;
};

typedef vector<deal> deals;

vector<deals> fraction;

bool byProfit(const deal &a, const deal &b) {
    return a.profit > b.profit;
}

int column(int m, int i) {
    return m-i+1;
}

void eliminate(int m) {
    vector<int> a(m+1);
    a[0] = 1;

    int offset = 0;
    while (offset <= m-1) {
        int intel = m;

        a[offset]--;
        m -= a[offset]*column(m, offset);

        for (int k = offset+1; k <= m; k++) {
            int i = column(m, k);

            int v = intel / i;
            a[k] = v;

            cout << "intel is " << intel << endl;

            intel -= i*v;
        }

        for (int i = 1; i <= m; i++) {
            printf("%d ", a[i]);
        }
        printf("\n");

        if (a[offset] == 0) {
            offset++;
        }
    }
}

int main() {
    freopen("profit.in", "r", stdin);
    freopen("profit.out", "w", stdout);

    scanf("%d %d\n", &m, &n);
    fraction.resize(m+1);

    for (int j = 1; j <= m; j++) {
        fraction[j].resize(n+1);
        for (int k = 1; k <= n; k++) {
            deal x;
            x.bank = k;
            scanf("%d", &x.profit);

            fraction[j][k] = x;
        }

        sort(fraction[j].begin()+1, fraction[j].end(), byProfit);
    }

    printf("14\n0 0 1 2 0 0 0 0 0 0\n");

    return 0;
}
